/****************************************************************************
 * 
 * tcpurify - randtable.h
 * 
 * This program is Copyright 2000, 2001 by Ethan Blanton; please see the
 * accompanying copy of the GNU General Public License for your rights
 * regarding the usage and distribution of this software.
 * 
 ***************************************************************************/

#ifndef RANDTABLE_H
#define RANDTABLE_H

#include <inttypes.h>
#include <stdio.h>
#include "tcpurify.h"

uint32_t squish(uint32_t x, uint32_t mask);
uint32_t unsquish(uint32_t x, uint32_t mask);
uint32_t *table_compress(uint32_t *table, uint32_t mask);
uint32_t *table_expand(uint32_t *compressed, uint32_t mask);
int table_create(struct Network *network);
int table_write(FILE *fp, const struct Network *network);
int table_read(FILE *fp, struct Network *network, int reverse);
int mask_bits(uint32_t mask);
void swap(uint32_t *table, uint32_t x, uint32_t y);
void shuffle(uint32_t *table, uint32_t size);

#endif /* RANDTABLE_H */
