/****************************************************************************
 * 
 * tcpurify - tcpurify.h
 * 
 * This program is Copyright 2000, 2001 by Ethan Blanton; please see the
 * accompanying copy of the GNU General Public License for your rights
 * regarding the usage and distribution of this software.
 * 
 ***************************************************************************/

#ifndef TCPURIFY_H
#define TCPURIFY_H

#include <sys/types.h>
#include <inttypes.h>
#include <stdio.h>
#include <zlib.h>
#include <pcap.h>

#define VERSION "0.9.5"
#define NETWORKS 16		/* The max network triplets allowed	*/
#define PKT_LEN 64		/* This should be enough for any headers*/

struct Config {
  int debug;			/* debugging output on/off		*/
  int truncate;			/* truncate packets on/off		*/
  int timed;			/* real-time output on/off		*/
  int reverse;			/* is the mapping file for reverse-map? */
  uint32_t maxtime;		/* maximum time between realtime packets*/
  char *interface;		/* interface to capture (i.e. eth0)	*/
  char *filename;		/* filename to treat as an interface	*/
  char *outfile;		/* output filename			*/
  char *mapfile;		/* mapping table			*/
  pcap_dumper_t *d;		/* pcap dumper				*/
  pcap_t *p;			/* associated pcap_t			*/
};

struct Network {
  uint32_t subnet;		/* i.e. 192.168.1.0			*/
  uint32_t netmask;		/* netmask for the transformed subnet	*/
  uint32_t xformmask;		/* bits to randomize			*/
  uint32_t *table;		/* random mapping table			*/
};

struct Times {
  struct timeval wall;		/* wall clock time beginning a RT dump	*/
  struct timeval virt;		/* time of the first packet in a RT dump*/
  struct timeval off;		/* Offset between wall & virt		*/
};

#endif /* TCPURIFY_H */
